///////////////////////////////////////////////////////////////////////////////////////////////////////
作者:tt2767
声明:本文遵循以下协议自由转载-非商用-非衍生-保持署名|Creative Commons BY-NC-ND 3.0
查看本文更新与讨论请点击:http://blog.csdn.net/tt2767
链接被删请百度: CSDN tt2767
///////////////////////////////////////////////////////////////////////////////////////////////////////
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4430
题解:
本题根据蛋糕中心放不放蜡烛可以转化为
已知:等比数列求和公式
我们知道18 ≤ n ≤ 1012 由此可以求出来r最大是45
由于r是有限d,所以我们可以枚举r,然后从结果中二分查找k的值。
如果把r当作已知量,对于k来说,可以用
故在
#include<sstream>
#include<string>
#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include <iterator>
#include<vector>
#include<map>
#include <stack>
#include<queue>
#include <list>
#include<functional>
#include<numeric>
using namespace std;
#define lch(x) ((x) << 1)
#define rch(x) ((x)<<1|1)
#define dad(x) ((x)>>1)
inline int lowbit(int x){return x&(-x);}
typedef long long int LL;
const int INF = 0x5f5f5f5f ;
const double eps = 1e-6;
const long double PI = acos(0.0) * 2.0;
LL R,K,n;
LL Power(LL x, LL y);
void judge(LL r,LL k,LL& R,LL& K );
int main()
{
while(scanf("%lld",&n)==1)
{
K = n-1,R = 1;
for(int r = 2 ; r <= 45 ; r++) //枚举r
{ //k的右边界由等比数列缩放而来
LL left = 2 , right = (LL)pow(n+1,1.0/r);
while(left <= right)
{
LL mid = (left+right)>>1; //二分查找k
LL ans = mid*(Power(mid,r)-1)/(mid-1);//等比数列求和计算结果
if(ans == n || ans == n-1)//符合中心放或者不放蜡烛的时候
{
judge(r,mid,R,K); //更新R,K的值
break;
}
else if(ans > n )
right = mid - 1;
else
left = mid + 1;
}
}
printf("%lld %lld\n",R,K);
}
return 0;
}
LL Power(LL x, LL y)
{
LL res = 1;
for(LL i = 0 ; i < y ; i++)
res *= x;
return res;
}
void judge(LL r,LL k,LL& R,LL& K )
{
if(r*k < R*K)
{
R = r;
K = k;
}
else if(r*k == R*K && r < R)
{
R = r;
K = k;
}
}
版权声明:本文为博主原创文章,允许非商业性转载,转载必须注名作者(CSDN tt2767)与本博客链接:http://blog.csdn.net/tt2767。
hdu4430_Yukari's Birthday(数学放缩+二分)
原文地址:http://blog.csdn.net/tt2767/article/details/47317807